import 'bootstrap/dist/css/bootstrap.min.css';
import { useFormikContext, useField } from 'formik';
import { createElement, Fragment } from 'react';
import { FormLabel, FormControl, FormGroup, FormCheck } from 'react-bootstrap';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function fieldToFormControl(_ref) {
  var disabled = _ref.disabled,
      name = _ref.name,
      props = _objectWithoutPropertiesLoose(_ref, ["noFormGroup", "children", "label", "disabled", "name"]);

  var _useFormikContext = useFormikContext(),
      isSubmitting = _useFormikContext.isSubmitting;

  var _useField = useField(name),
      field = _useField[0],
      meta = _useField[1];

  var fieldError = meta.error;
  var showError = meta.touched && !!fieldError;
  return _extends({}, field, {}, props, {
    isInvalid: showError,
    disabled: disabled !== null && disabled !== void 0 ? disabled : isSubmitting
  });
}
function fieldToFeedBack(_ref2) {
  var name = _ref2.name;

  var _useField2 = useField(name),
      error = _useField2[1].error;

  return error;
}
var FormikControl = function FormikControl(props) {
  var Core = createElement(Fragment, null, createElement(FormLabel, null, props.label), createElement(FormControl, Object.assign({
    as: props.as
  }, fieldToFormControl(props)), props.children), createElement(FormControl.Feedback, {
    type: "invalid"
  }, fieldToFeedBack(props)));
  return props.noFormGroup ? Core : createElement(FormGroup, null, Core);
};

function fieldToFormCheck(_ref) {
  var disabled = _ref.disabled,
      custom = _ref.custom,
      id = _ref.id,
      name = _ref.name,
      props = _objectWithoutPropertiesLoose(_ref, ["disabled", "custom", "id", "name"]);

  var _useFormikContext = useFormikContext(),
      isSubmitting = _useFormikContext.isSubmitting;

  var _useField = useField(name),
      field = _useField[0],
      meta = _useField[1];

  var fieldError = meta.error;
  var showError = meta.touched && !!fieldError;

  var _useField2 = useField(name),
      error = _useField2[1].error;

  if (props.value && field.value) {
    field.checked = props.value.toString() === field.value.toString();
  }

  return _extends({}, field, {}, props, {
    disabled: disabled !== null && disabled !== void 0 ? disabled : isSubmitting,
    custom: custom !== null && custom !== void 0 ? custom : true,
    id: id !== null && id !== void 0 ? id : "check-" + name + (props.value ? '-' + props.value : ''),
    isInvalid: showError,
    feedback: error
  });
}
var FormikCheck = function FormikCheck(props) {
  return createElement(FormGroup, null, createElement(FormCheck, Object.assign({}, fieldToFormCheck(props))));
};

export { FormikCheck, FormikControl, fieldToFeedBack, fieldToFormCheck, fieldToFormControl };
//# sourceMappingURL=formik-react-bootstrap.esm.js.map
